SystemOrganization addCategory: #'GMF-UMLModel'!

Object subclass: #TransformToUML
	instanceVariableNames: 'dataToTransform element transformedElements dataForGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

!TransformToUML class methodsFor: 'instance creation' stamp: 'Anonymous 5/8/2013 18:16'!
dataToTransform: xData

	^(super new initialize)
		dataToTransform: xData;
		yourself! !

!TransformToUML methodsFor: 'private' stamp: 'volosmat 5/19/2013 22:56'!
createDataForGenerator
	| class attr method |
	transformedElements
		do: [:a | 
			class := GeneratedClass newName: a name.
			a attributs
				do: [:b | 
					attr := GeneratedEOCVariable newName: b name Instance: b isInstance.
					( ( b quantity = '1..*' ) | ( b quantity = '0..*' ) )
						ifTrue: [ attr collection: 'OrderedCollection'. ].
						
					class addVariable: attr].
			a compositions
				do: [:b | 
					( b start name = a name )
						ifTrue: [ attr := GeneratedEOCVariable newName: b name.
								 ( ( b endMultiplicity = '1..*' ) | ( b endMultiplicity = '0..*' ) )
								 	ifTrue: [ attr collection: 'OrderedCollection'. ].
								 class addVariable: attr.  ].
					].
			a methods 
				do: [ :b | 
					method := GeneratedEOCMethod newName: b name Instance: b isInstance Abstract: b isAbstract.
					b parameters 
						do: [ :c |
							method addArgument: ( GeneratedEOCVariable newName: c ) ].
					class addMethod: method ].
			( a parent notNil )
				ifTrue: [ class parent: ( self findClass: a parent name ) ].
			dataForGenerator addClass: class. 
			]. ! !

!TransformToUML methodsFor: 'accessing' stamp: 'volosmat 5/11/2013 14:32'!
dataForGenerator
	^ dataForGenerator! !

!TransformToUML methodsFor: 'accessing' stamp: 'volosmat 5/11/2013 14:32'!
dataForGenerator: anObject
	dataForGenerator := anObject! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 18:15'!
dataToTransform
	^ dataToTransform! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 18:16'!
dataToTransform: anObject
	dataToTransform := anObject! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:59'!
element
	^ element! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:59'!
element: anObject
	element := anObject! !

!TransformToUML methodsFor: 'private' stamp: 'volosmat 5/11/2013 15:00'!
findClass: xName  
      "najde triedu v datach pre generator podla mena"
	dataForGenerator classes do: [ :b | ( b name = xName ) ifTrue: [ ^b. ] ].
	^nil.! !

!TransformToUML methodsFor: 'private' stamp: 'Anonymous 5/9/2013 08:33'!
findElement: xClass 
      "najdenie elementu v datach spacifickeho typu xClass"
	dataToTransform do: [ :b | b isTransformed not & ( b class = xClass ) ifTrue: [ element := b. ^true. ] ].
	^false.! !

!TransformToUML methodsFor: 'private' stamp: 'Anonymous 5/9/2013 16:17'!
findElement: xClass name: xName
      "najdenie elementu v datach spacifickeho typu xClass a name xName"
	dataToTransform do: [ :b | b isTransformed not & ( b class = xClass ) & ( b name = xName ) ifTrue: [ ^b. ] ].
	^nil.! !

!TransformToUML methodsFor: 'private' stamp: 'Anonymous 5/9/2013 16:26'!
findTransformedElement: xName
      "najdenie elementu v uz transformovanych elementoch spacifickeho typu xClass a name xName"
	transformedElements do: [ :b | ( b name = xName ) ifTrue: [ ^b. ] ].
	^nil.! !

!TransformToUML methodsFor: 'initialize-release' stamp: 'volosmat 5/11/2013 14:59'!
initialize

	transformedElements	 := OrderedCollection new.
	dataForGenerator		 := GeneratedAll new.
			
	^ self! !

!TransformToUML methodsFor: 'private' stamp: 'Anonymous 5/9/2013 08:35'!
isTransformed
	"prejdenie celej kolekce dat a zistenie ci su vsetky elementy prevedene"
	^dataToTransform allSatisfy: [:b | b isTransformed ].! !

!TransformToUML methodsFor: 'private' stamp: 'Anonymous 5/9/2013 08:33'!
readNextElement
	"nacitanie noveho elementu v poradi z data na transform"
	element := dataToTransform detect: [ :b | b isTransformed not ].! !

!TransformToUML methodsFor: 'methods' stamp: 'Anonymous 5/9/2013 08:43'!
transformAll
	"prevedenie vsetkych elementov najprv Category a kind a potom ostatne"
	[ self findElement: Category ] whileTrue: [ 
 	  	self transformElement.	  
	].
	
	[ self findElement: Kind ] whileTrue: [ 
 	  	self transformElement.	  
	].


	[self isTransformed] whileFalse: [
		self readNextElement.
		self transformElement. ]! !

!TransformToUML methodsFor: 'transformMethods' stamp: 'volosmat 5/11/2013 14:03'!
transformAssociation: xUMLElement 
	| composition tmpStart tmpEnd tmpStartElem tmpEndElem |
	element associations
		do: [:a | 
			tmpStart := self findTransformedElement: a start name.
			tmpEnd := self findTransformedElement: a end name. 
			( tmpStart isNil )
				ifTrue: [tmpStartElem := self findElement: a start class name: a start name.
					self transformElement: tmpStartElem].
			( tmpEnd isNil )
				ifTrue: [tmpEndElem := self findElement: a end class name: a end name.
					self transformElement: tmpEndElem].
				
			composition := UMLCompositions
						name: a name
						start: a start
						startMultiplicity: a startQuantity
						end: a end
						endMultiplicity: a endQuantity.
			xUMLElement compositions add: composition]! !

!TransformToUML methodsFor: 'transformMethods' stamp: 'volosmat 5/11/2013 14:20'!
transformAssociation: xUMLElement sourceElement: xOntoElement
	| composition tmpStart tmpEnd tmpStartElem tmpEndElem |
	xOntoElement associations
		do: [:a | 
			tmpStart := self findTransformedElement: a start name.
			tmpEnd := self findTransformedElement: a end name. 
			( tmpStart isNil )
				ifTrue: [tmpStartElem := self findElement: a start class name: a start name.
					self transformElement: tmpStartElem].
			( tmpEnd isNil )
				ifTrue: [tmpEndElem := self findElement: a end class name: a end name.
					self transformElement: tmpEndElem].
				
			composition := UMLCompositions
						name: a name
						start: a start
						startMultiplicity: a startQuantity
						end: a end
						endMultiplicity: a endQuantity.
			xUMLElement compositions add: composition]

					
				! !

!TransformToUML methodsFor: 'private' stamp: 'volosmat 5/11/2013 13:53'!
transformElement
	| tmp attributs methods xParent trans |
	"transformovanie elementu z onto uml do uml"
	trans := false.
	( element parent size = 0 )
		ifTrue: [ tmp := UMLElement name: element name isAbstract: element isAbstract. ].
	( element parent size = 1 )
		ifTrue: [ 
			"everim ci nejde o specialne pripady kde sa dedenie transformuje inak"
			( element class = Phase )
				ifTrue: [ self transformPhase. ^true. ].
			( element class = Role )
				ifTrue: [ self transformRole. ^true. ].
			( trans = false )
				ifTrue: [ xParent := self transformElement: element parent first.
						 tmp := UMLElement name: element name parent: xParent isAbstract: element isAbstract isDisjoint: element isDisjoint. ].
			      ].
	( element parent size > 1 )
		ifTrue: [ "TODO vicenasobna dedicnost"  ].
	
	( element methods size > 0 )
		ifTrue: [ methods := element methods copy.
				 tmp methods: methods.  ].
	( element attributs size > 0 )
		ifTrue: [ attributs := element attributs copy.
				 tmp attributs: attributs. ].
	
	element isTransformed: true.
	transformedElements add: tmp.
	
	( element associations size > 0 )
		ifTrue: [ self transformAssociation: tmp. ].
		
! !

!TransformToUML methodsFor: 'private' stamp: 'volosmat 5/11/2013 14:07'!
transformElement: xElement
	| tmp xParent tmp2 methods attributs trans |
	"transformovanie elementu xElement z onto uml do uml"
	tmp := self findTransformedElement: xElement name.
	( tmp notNil )
		ifTrue: [ ^tmp ].
	
	tmp2 := self findElement: xElement class name: xElement name.
	trans := false.
	"element nema rodica"
	( tmp2 parent size = 0 )
		ifTrue: [ tmp := UMLElement name: tmp2 name isAbstract: tmp2 isAbstract . ].
	"element ma prave 1 rodica"
	( tmp2 parent size = 1 )
		ifTrue: [ 
			( tmp2 class = Phase )
				ifTrue: [ self transformPhase: tmp2. ^true ].
			( tmp2 class = Role )
				ifTrue: [ self transformRole: tmp2. ^true ].
			( trans = false )
				ifTrue: [ xParent := self transformElement: tmp2 parent first.
						 tmp := UMLElement name: tmp2 name parent: xParent isAbstract: tmp2 isAbstract isDisjoint: tmp2 isDisjoint. ].
			].
	"element ma viac ako 1 rodica tj. vicenasobna dedicnost"
	( tmp2 parent size > 1 )
		ifTrue: [ "TODO vicenasobna dedicnost" ].
	
	( tmp2 methods size > 0 )
		ifTrue: [ methods := tmp2 methods copy.
				 tmp methods: methods.  ].
	( tmp2 attributs size > 0 )
		ifTrue: [ attributs := tmp2 attributs copy.
				 tmp attributs: attributs. ].	
	
	tmp2 isTransformed: true.
	transformedElements add: tmp.
	
	( tmp2 associations size > 0 )
		ifTrue: [ self transformAssociation: tmp sourceElement: tmp2. ].
		
! !

!TransformToUML methodsFor: 'transformMethods' stamp: 'volosmat 5/10/2013 13:58'!
transformPhase
	| tmp xParent methods attributs |
	( element parent size = 1 )
		ifTrue: [ xParent := self transformElement: element parent first.
			       tmp := UMLElement name: element name isAbstract: element isAbstract. 
				 xParent XOR add: tmp.
			    ];
		ifFalse: [ "TODO vicenasobna dedicnost" ].
	
	( element methods size > 0 )
		ifTrue: [ methods := element methods copy.
				 tmp methods: methods.  ].
	( element attributs size > 0 )
		ifTrue: [ attributs := element attributs copy.
				 tmp attributs: attributs. ].
	
	element isTransformed: true.
	transformedElements add: tmp.
		! !

!TransformToUML methodsFor: 'transformMethods' stamp: 'volosmat 5/10/2013 13:57'!
transformPhase: xElement
	| tmp xParent methods attributs |
	( xElement parent size = 1 )
		ifTrue: [ xParent := self transformElement: xElement parent first.
			       tmp := UMLElement name: xElement name isAbstract: xElement isAbstract. 
				 xParent XOR add: tmp.
			    ];
		ifFalse: [ "TODO vicenasobna dedicnost" ].
	
	( xElement methods size > 0 )
		ifTrue: [ methods := xElement methods copy.
				 tmp methods: methods.  ].
	( xElement attributs size > 0 )
		ifTrue: [ attributs := xElement attributs copy.
				 tmp attributs: attributs. ].
	
	xElement isTransformed: true.
	transformedElements add: tmp.
		! !

!TransformToUML methodsFor: 'transformMethods' stamp: 'volosmat 5/10/2013 13:38'!
transformRole
	| tmp xParent methods attributs |
	( element parent size = 1 )
		ifTrue: [ xParent := self transformElement: element parent first.
			       tmp := UMLElement name: element name parent: xParent isAbstract: element isAbstract isDisjoint: element isDisjoint. ];
		ifFalse: [ "TODO vicenasobna dedicnost" ].
	
	( element methods size > 0 )
		ifTrue: [ methods := element methods copy.
				 tmp methods: methods.  ].
	( element attributs size > 0 )
		ifTrue: [ attributs := element attributs copy.
				 tmp attributs: attributs. ].
	
	element isTransformed: true.
	transformedElements add: tmp.
		! !

!TransformToUML methodsFor: 'transformMethods' stamp: 'volosmat 5/10/2013 13:38'!
transformRole: xElement
	| tmp xParent methods attributs |
	( xElement parent size = 1 )
		ifTrue: [ xParent := self transformElement: xElement parent first.
			       tmp := UMLElement name: xElement name parent: xParent isAbstract: xElement isAbstract isDisjoint: xElement isDisjoint. ];
		ifFalse: [ "TODO vicenasobna dedicnost" ].
	
	( xElement methods size > 0 )
		ifTrue: [ methods := xElement methods copy.
				 tmp methods: methods.  ].
	( xElement attributs size > 0 )
		ifTrue: [ attributs := xElement attributs copy.
				 tmp attributs: attributs. ].
	
	xElement isTransformed: true.
	transformedElements add: tmp.
		! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:59'!
transformedElements
	^ transformedElements! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:59'!
transformedElements: anObject
	transformedElements := anObject! !

Object subclass: #UMLCompositions
	instanceVariableNames: 'start end name startMultiplicity endMultiplicity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

!UMLCompositions class methodsFor: 'instance creation' stamp: 'volosmat 5/11/2013 13:34'!
name: xName start: xStart end: xEnd endMultiplicity: xEndMulti 
	^ super new initialize name: xName;
		 start: xStart;
		 end: xEnd;
		 endMultiplicity: xEndMulti;
		 yourself! !

!UMLCompositions class methodsFor: 'instance creation' stamp: 'volosmat 5/11/2013 13:34'!
name: xName start: xStart startMultiplicity: xStartMulti end: xEnd
	^ super new initialize name: xName;
		 start: xStart;
		 end: xEnd;
		 startMultiplicity: xStartMulti;
		 yourself! !

!UMLCompositions class methodsFor: 'instance creation' stamp: 'volosmat 5/11/2013 13:34'!
name: xName start: xStart startMultiplicity: xStartMulti end: xEnd endMultiplicity: xEndMulti
	^ super new initialize 
		 name: xName;
		 start: xStart;
		 end: xEnd;
		 startMultiplicity: xStartMulti;
		 endMultiplicity: xEndMulti;
		 yourself! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:30'!
end
	^ end! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:30'!
end: anObject
	end := anObject! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:31'!
endMultiplicity
	^ endMultiplicity! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:31'!
endMultiplicity: anObject
	endMultiplicity := anObject! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:31'!
name
	^ name! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:31'!
name: anObject
	name := anObject! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:31'!
start
	^ start! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:31'!
start: anObject
	start := anObject! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:31'!
startMultiplicity
	^ startMultiplicity! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:31'!
startMultiplicity: anObject
	startMultiplicity := anObject! !

Object subclass: #UMLElement
	instanceVariableNames: 'attributs methods compositions parent name isAbstract isDisjoint XOR'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

!UMLElement class methodsFor: 'instance creation' stamp: 'volosmat 5/10/2013 10:46'!
name: xName

	^(super new initialize)
		name: xName;
		parent: nil;
		isDisjoint: nil;
		yourself! !

!UMLElement class methodsFor: 'instance creation' stamp: 'volosmat 5/10/2013 10:46'!
name: xName isAbstract: xAbstract

	^(super new initialize)
		name: xName;
		isAbstract: xAbstract;
		parent: nil;
		isDisjoint: nil;
		yourself! !

!UMLElement class methodsFor: 'instance creation' stamp: 'volosmat 5/10/2013 10:47'!
name: xName parent: xParent

	^(super new initialize)
		name: xName;
		parent: xParent;
		isDisjoint: true;
		yourself! !

!UMLElement class methodsFor: 'instance creation' stamp: 'volosmat 5/10/2013 10:47'!
name: xName parent: xParent isAbstract: xAbstract

	^(super new initialize)
		name: xName;
		parent: xParent;
		isAbstract: xAbstract;
		isDisjoint: true;
		yourself! !

!UMLElement class methodsFor: 'instance creation' stamp: 'volosmat 5/10/2013 10:44'!
name: xName parent: xParent isAbstract: xAbstract isDisjoint: xIsDisjoint

	^(super new initialize)
		name: xName;
		parent: xParent;
		isAbstract: xAbstract;
		isDisjoint: xIsDisjoint;
		yourself! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 5/10/2013 11:13'!
XOR
	^ XOR! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 5/10/2013 11:14'!
XOR: anObject
	XOR := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:47'!
attributs
	^ attributs! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:47'!
attributs: anObject
	attributs := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:47'!
compositions
	^ compositions! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:47'!
compositions: anObject
	compositions := anObject! !

!UMLElement methodsFor: 'initialize-release' stamp: 'volosmat 5/10/2013 13:24'!
initialize
	"set numbers of used classes and relations to empty"

	attributs := OrderedCollection new.
	methods := OrderedCollection new.
	compositions := OrderedCollection new.
	XOR := OrderedCollection new.
	isAbstract := false.
	isDisjoint  := true.
	^ self! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:34'!
isAbstract
	^ isAbstract! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:34'!
isAbstract: anObject
	isAbstract := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 5/10/2013 10:43'!
isDisjoint
	^ isDisjoint! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 5/10/2013 10:43'!
isDisjoint: anObject
	isDisjoint := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
methods
	^ methods! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
methods: anObject
	methods := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
name
	^ name! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
name: anObject
	name := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
parent
	^ parent! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 5/10/2013 10:46'!
parent: anObject
	parent := anObject.
	isDisjoint := true.
! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 5/10/2013 13:25'!
parent: anObject isDisjoint: xDis
	parent := anObject.
	isDisjoint := xDis.
! !
